SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #OOStack
	instanceVariableNames: 'content top'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 21:31'!
initialize 
	top := StackBase new.
	content := OrderedCollection with: top.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:51'!
isEmpty
	^content size = 1 ! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:53'!
last
	^content last! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:46'!
pop
	|currentTop|
	currentTop := top content.
	top removeFrom: self.
	^currentTop! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 21:31'!
push: anObject 
	
	top := StackedElement newFor: anObject.
	content add: top.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:53'!
removeLast
	^content removeLast.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:51'!
size 	
	^content size - 1! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:38'!
top
	^top content! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:50'!
top: aTop
	^top := aTop! !

Object subclass: #StackElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

StackElement subclass: #StackBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!StackBase class methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:56'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!StackBase methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:41'!
content
	Error signal:  self class stackEmptyErrorDescription! !

!StackBase methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:49'!
removeFrom: aStack 
	Error signal:  self class stackEmptyErrorDescription! !

StackElement subclass: #StackedElement
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!StackedElement class methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:52'!
newFor: anObject 	
	^self new for: anObject! !

!StackedElement methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:40'!
content
	^content! !

!StackedElement methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:40'!
for: anObject
	content := anObject! !

!StackedElement methodsFor: 'as yet unclassified' stamp: 'achavez 5/6/2013 20:48'!
removeFrom: aStack 
	aStack removeLast.
	aStack top: aStack last.! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test09CanNotPopWhenThereAreNoObjectsInTheStackAndTheStackHadObjects

	| stack  |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test10CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
